/*******************************************************************\

Module: Boolean Literals 

Author: CM Wintersteiger

\*******************************************************************/

#ifndef LITERAL_H_
#define LITERAL_H_

class Literal {
  private:
    unsigned l;
  
  public:
    Literal( unsigned, bool );
    Literal( signed );
        
    inline unsigned variable( void ) const { return ( l >> 1 ); };
    inline bool sign( void ) const { return ( l & 0x1 ); };
    
    inline void set( unsigned v, bool s) { l = (v << 1) | s; };
    inline void invert( void ) { l = l ^ 0x1; }
    
    signed long long to_dimacs( void ) const;
    
    // Operators
    inline bool operator==(const Literal& r) const
      { return (this->l == r.l); };
    inline bool operator==(unsigned r) const
      { return ((this->l >> 1) == r); };
    inline Literal& operator=(const Literal& r)
      { this->l = r.l; return *this; };
    inline Literal operator~(void) const
      { Literal t=*this; t.invert(); return t; };
};

#endif
